/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf 11805 2005-01-07 09:37:18Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "h4aChassis.h"

#include "../utils_chassis.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif

/** Initializes the h4aChassis module */
void
init_h4aChassis(void)
{
    static oid      h4aTempBoard_oid[] =
        { 1, 3, 6, 1, 4, 1, 38957, 1024, 1, 1, 1 };
    static oid      h4aTempCpu_oid[] =
        { 1, 3, 6, 1, 4, 1, 38957, 1024, 1, 1, 2 };

    DEBUGMSGTL(("h4aChassis", "Initializing\n"));

    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("h4aTempBoard", handle_h4aTempBoard,
                             h4aTempBoard_oid,
                             OID_LENGTH(h4aTempBoard_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("h4aTempCpu", handle_h4aTempCpu,
                             h4aTempCpu_oid, OID_LENGTH(h4aTempCpu_oid),
                             HANDLER_CAN_RONLY));
}

int
handle_h4aTempBoard(netsnmp_mib_handler *handler,
                    netsnmp_handler_registration *reginfo,
                    netsnmp_agent_request_info *reqinfo,
                    netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    switch (reqinfo->mode) {

    case MODE_GET:
        //&&&
        {
        int value=-256;
        int sts;
        sts = get_temperature (1, &value);
        if (sts > 0) return SNMP_ERR_GENERR;
        value=value/1000;

        snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                 (u_char *)&value, sizeof(value));
        value=-1;
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_h4aTempBoard\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_h4aTempCpu(netsnmp_mib_handler *handler,
                  netsnmp_handler_registration *reginfo,
                  netsnmp_agent_request_info *reqinfo,
                  netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

    switch (reqinfo->mode) {

    case MODE_GET:
        //&&&
        {
        int value=-256;
        int sts;
        sts = get_temperature (2, &value);
        if (sts > 0) return SNMP_ERR_GENERR;
        value=value/1000;

        snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                 (u_char *)&value, sizeof(value));
        value=-2;
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_h4aTempCpu\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
