/*
 * Note: this file originally auto-generated by mib2c using
 *       version : 12088 $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "h4aWlanStnTable.h"


#ifdef DMALLOC
#include <dmalloc.h>
#endif

/** @defgroup data_get data_get: Routines to get data
 *
 * TODO:230:M: Implement h4aWlanStnTable get routines.
 * TODO:240:M: Implement h4aWlanStnTable mapping routines (if any).
 *
 * These routine are used to get the value for individual objects. The
 * row context is passed, along with a pointer to the memory where the
 * value should be copied.
 *
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table h4aWlanStnTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * HAMNET-ALIX-MIB::h4aWlanStnTable is subid 2 of h4aWlanStn.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.2.2, length: 12
 */

/*
 * ---------------------------------------------------------------------
 * * TODO:200:r: Implement h4aWlanStnTable data context functions.
 */


/**
 * set mib index(es)
 *
 * @param tbl_idx mib index structure
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This convenience function is useful for setting all the MIB index
 *  components with a single function call. It is assume that the C values
 *  have already been mapped from their native/rawformat to the MIB format.
 */
int
h4aWlanStnTable_indexes_set_tbl_idx(h4aWlanStnTable_mib_index * tbl_idx,
                                    long h4aWlanStnIndex_val)
{
    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnTable_indexes_set_tbl_idx", "called\n"));

    /*
     * h4aWlanStnIndex(1)/INTEGER32/ASN_INTEGER/long(long)//l/A/w/e/r/d/h 
     */
    tbl_idx->h4aWlanStnIndex = h4aWlanStnIndex_val;


    return MFD_SUCCESS;
}                               /* h4aWlanStnTable_indexes_set_tbl_idx */

/**
 * @internal
 * set row context indexes
 *
 * @param reqreq_ctx the row context that needs updated indexes
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This function sets the mib indexs, then updates the oid indexs
 *  from the mib index.
 */
int
h4aWlanStnTable_indexes_set(h4aWlanStnTable_rowreq_ctx * rowreq_ctx,
                            long h4aWlanStnIndex_val)
{
    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnTable_indexes_set",
                "called\n"));

    if (MFD_SUCCESS !=
        h4aWlanStnTable_indexes_set_tbl_idx(&rowreq_ctx->tbl_idx,
                                            h4aWlanStnIndex_val))
        return MFD_ERROR;

    /*
     * convert mib index to oid index
     */
    rowreq_ctx->oid_idx.len = sizeof(rowreq_ctx->oid_tmp) / sizeof(oid);
    if (0 != h4aWlanStnTable_index_to_oid(&rowreq_ctx->oid_idx,
                                          &rowreq_ctx->tbl_idx)) {
        return MFD_ERROR;
    }

    return MFD_SUCCESS;
}                               /* h4aWlanStnTable_indexes_set */


/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanStnEntry.h4aWlanStnIfName
 * h4aWlanStnIfName is subid 2 of h4aWlanStnEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.2.2.1.2
 * Description:
Interface Name.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 32a
 *
 * Ranges:  0 - 32;
 *
 * Its syntax is DisplayString32 (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 32)
 */
/**
 * Extract the current value of the h4aWlanStnIfName data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanStnIfName_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param h4aWlanStnIfName_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by h4aWlanStnIfName.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*h4aWlanStnIfName_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update h4aWlanStnIfName_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
h4aWlanStnIfName_get(h4aWlanStnTable_rowreq_ctx * rowreq_ctx,
                     char **h4aWlanStnIfName_val_ptr_ptr,
                     size_t *h4aWlanStnIfName_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != h4aWlanStnIfName_val_ptr_ptr)
                   && (NULL != *h4aWlanStnIfName_val_ptr_ptr));
    netsnmp_assert(NULL != h4aWlanStnIfName_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnIfName_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanStnIfName data.
     * copy (* h4aWlanStnIfName_val_ptr_ptr ) data and (* h4aWlanStnIfName_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for h4aWlanStnIfName data
     */
    if ((NULL == (*h4aWlanStnIfName_val_ptr_ptr)) ||
        ((*h4aWlanStnIfName_val_ptr_len_ptr) <
         (rowreq_ctx->data.h4aWlanStnIfName_len *
          sizeof(rowreq_ctx->data.h4aWlanStnIfName[0])))) {
        /*
         * allocate space for h4aWlanStnIfName data
         */
        (*h4aWlanStnIfName_val_ptr_ptr) =
            malloc(rowreq_ctx->data.h4aWlanStnIfName_len *
                   sizeof(rowreq_ctx->data.h4aWlanStnIfName[0]));
        if (NULL == (*h4aWlanStnIfName_val_ptr_ptr)) {
            snmp_log(LOG_ERR, "could not allocate memory\n");
            return MFD_ERROR;
        }
    }
    (*h4aWlanStnIfName_val_ptr_len_ptr) =
        rowreq_ctx->data.h4aWlanStnIfName_len *
        sizeof(rowreq_ctx->data.h4aWlanStnIfName[0]);
    memcpy((*h4aWlanStnIfName_val_ptr_ptr),
           rowreq_ctx->data.h4aWlanStnIfName,
           rowreq_ctx->data.h4aWlanStnIfName_len *
           sizeof(rowreq_ctx->data.h4aWlanStnIfName[0]));

    return MFD_SUCCESS;
}                               /* h4aWlanStnIfName_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanStnEntry.h4aWlanStnMacLocal
 * h4aWlanStnMacLocal is subid 3 of h4aWlanStnEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.2.2.1.3
 * Description:
MAC Address of local station.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 1x:
 *
 * Ranges:  6;
 *
 * Its syntax is MacAddress (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 6)
 */
/**
 * Extract the current value of the h4aWlanStnMacLocal data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanStnMacLocal_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param h4aWlanStnMacLocal_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by h4aWlanStnMacLocal.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*h4aWlanStnMacLocal_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update h4aWlanStnMacLocal_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
h4aWlanStnMacLocal_get(h4aWlanStnTable_rowreq_ctx * rowreq_ctx,
                       char **h4aWlanStnMacLocal_val_ptr_ptr,
                       size_t *h4aWlanStnMacLocal_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != h4aWlanStnMacLocal_val_ptr_ptr)
                   && (NULL != *h4aWlanStnMacLocal_val_ptr_ptr));
    netsnmp_assert(NULL != h4aWlanStnMacLocal_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnMacLocal_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanStnMacLocal data.
     * copy (* h4aWlanStnMacLocal_val_ptr_ptr ) data and (* h4aWlanStnMacLocal_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for h4aWlanStnMacLocal data
     */
    if ((NULL == (*h4aWlanStnMacLocal_val_ptr_ptr)) ||
        ((*h4aWlanStnMacLocal_val_ptr_len_ptr) <
         (rowreq_ctx->data.h4aWlanStnMacLocal_len *
          sizeof(rowreq_ctx->data.h4aWlanStnMacLocal[0])))) {
        /*
         * allocate space for h4aWlanStnMacLocal data
         */
        (*h4aWlanStnMacLocal_val_ptr_ptr) =
            malloc(rowreq_ctx->data.h4aWlanStnMacLocal_len *
                   sizeof(rowreq_ctx->data.h4aWlanStnMacLocal[0]));
        if (NULL == (*h4aWlanStnMacLocal_val_ptr_ptr)) {
            snmp_log(LOG_ERR, "could not allocate memory\n");
            return MFD_ERROR;
        }
    }
    (*h4aWlanStnMacLocal_val_ptr_len_ptr) =
        rowreq_ctx->data.h4aWlanStnMacLocal_len *
        sizeof(rowreq_ctx->data.h4aWlanStnMacLocal[0]);
    memcpy((*h4aWlanStnMacLocal_val_ptr_ptr),
           rowreq_ctx->data.h4aWlanStnMacLocal,
           rowreq_ctx->data.h4aWlanStnMacLocal_len *
           sizeof(rowreq_ctx->data.h4aWlanStnMacLocal[0]));

    return MFD_SUCCESS;
}                               /* h4aWlanStnMacLocal_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanStnEntry.h4aWlanStnMacRemote
 * h4aWlanStnMacRemote is subid 4 of h4aWlanStnEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.2.2.1.4
 * Description:
MAC Address of remote station.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 1x:
 *
 * Ranges:  6;
 *
 * Its syntax is MacAddress (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 6)
 */
/**
 * Extract the current value of the h4aWlanStnMacRemote data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanStnMacRemote_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param h4aWlanStnMacRemote_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by h4aWlanStnMacRemote.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*h4aWlanStnMacRemote_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update h4aWlanStnMacRemote_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
h4aWlanStnMacRemote_get(h4aWlanStnTable_rowreq_ctx * rowreq_ctx,
                        char **h4aWlanStnMacRemote_val_ptr_ptr,
                        size_t *h4aWlanStnMacRemote_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != h4aWlanStnMacRemote_val_ptr_ptr)
                   && (NULL != *h4aWlanStnMacRemote_val_ptr_ptr));
    netsnmp_assert(NULL != h4aWlanStnMacRemote_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnMacRemote_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanStnMacRemote data.
     * copy (* h4aWlanStnMacRemote_val_ptr_ptr ) data and (* h4aWlanStnMacRemote_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for h4aWlanStnMacRemote data
     */
    if ((NULL == (*h4aWlanStnMacRemote_val_ptr_ptr)) ||
        ((*h4aWlanStnMacRemote_val_ptr_len_ptr) <
         (rowreq_ctx->data.h4aWlanStnMacRemote_len *
          sizeof(rowreq_ctx->data.h4aWlanStnMacRemote[0])))) {
        /*
         * allocate space for h4aWlanStnMacRemote data
         */
        (*h4aWlanStnMacRemote_val_ptr_ptr) =
            malloc(rowreq_ctx->data.h4aWlanStnMacRemote_len *
                   sizeof(rowreq_ctx->data.h4aWlanStnMacRemote[0]));
        if (NULL == (*h4aWlanStnMacRemote_val_ptr_ptr)) {
            snmp_log(LOG_ERR, "could not allocate memory\n");
            return MFD_ERROR;
        }
    }
    (*h4aWlanStnMacRemote_val_ptr_len_ptr) =
        rowreq_ctx->data.h4aWlanStnMacRemote_len *
        sizeof(rowreq_ctx->data.h4aWlanStnMacRemote[0]);
    memcpy((*h4aWlanStnMacRemote_val_ptr_ptr),
           rowreq_ctx->data.h4aWlanStnMacRemote,
           rowreq_ctx->data.h4aWlanStnMacRemote_len *
           sizeof(rowreq_ctx->data.h4aWlanStnMacRemote[0]));

    return MFD_SUCCESS;
}                               /* h4aWlanStnMacRemote_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanStnEntry.h4aWlanStnRxLevel
 * h4aWlanStnRxLevel is subid 5 of h4aWlanStnEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.2.2.1.5
 * Description:
RX level in dBm of remote station.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: d
 *
 * Ranges:  -256 - 256;
 *
 * Its syntax is SignalLevel (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the h4aWlanStnRxLevel data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanStnRxLevel_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
h4aWlanStnRxLevel_get(h4aWlanStnTable_rowreq_ctx * rowreq_ctx,
                      long *h4aWlanStnRxLevel_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != h4aWlanStnRxLevel_val_ptr);


    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnRxLevel_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanStnRxLevel data.
     * copy (* h4aWlanStnRxLevel_val_ptr ) from rowreq_ctx->data
     */
    (*h4aWlanStnRxLevel_val_ptr) = rowreq_ctx->data.h4aWlanStnRxLevel;

    return MFD_SUCCESS;
}                               /* h4aWlanStnRxLevel_get */

/*---------------------------------------------------------------------
 * HAMNET-ALIX-MIB::h4aWlanStnEntry.h4aWlanStnTxRate
 * h4aWlanStnTxRate is subid 6 of h4aWlanStnEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.38957.1024.1.3.2.2.1.6
 * Description:
TX bitrate.
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is INTEGER32 (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the h4aWlanStnTxRate data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param h4aWlanStnTxRate_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
h4aWlanStnTxRate_get(h4aWlanStnTable_rowreq_ctx * rowreq_ctx,
                     long *h4aWlanStnTxRate_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != h4aWlanStnTxRate_val_ptr);


    DEBUGMSGTL(("verbose:h4aWlanStnTable:h4aWlanStnTxRate_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the h4aWlanStnTxRate data.
     * copy (* h4aWlanStnTxRate_val_ptr ) from rowreq_ctx->data
     */
    (*h4aWlanStnTxRate_val_ptr) = rowreq_ctx->data.h4aWlanStnTxRate;

    return MFD_SUCCESS;
}                               /* h4aWlanStnTxRate_get */



/** @} */
